# -*- coding: utf-8 -*-
#
# File: bittorrent.py
#
# Copyright (c) 2006 by Christof Haemmerle :: nex9 (USA), Andy Nicholson,
# Wolfgang Reutz
# Generator: ArchGenXML Version 1.5.0 svn/devel
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Christof Haemmerle <reco@nex9.com>, Andy Nicholson <andy@cat.org.au>,
Wolfgang Reutz <wolfgang.reutz@vol.at>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.ATContentTypes.content.file import ATFile
from Products.ATMediaFile.interfaces.IBitTorrentFile import IBitTorrentFile
from Products.ATMediaFile.config import *

##code-section module-header #fill in your manual code here
from Products.ExternalStorage.ExternalStorage import ExternalStorage
##/code-section module-header

schema = Schema((

    FileField(
        name='file',
        widget=FileWidget
        (
            label="BitTorrent File",
            description="Upload your BitTorrent file.",
            label_msgid='ATMediaFile_label_file',
            description_msgid='ATMediaFile_help_file',
            i18n_domain='ATMediaFile',
        ),
        languageIndependent=1,
        storage=ExternalStorage(prefix=FS_DIRECTORY, archive=False, rename=True),
        primary=1,
        required=1
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BitTorrentFile_schema = getattr(ATFile, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BitTorrentFile(ATFile):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(ATFile,'__implements__',()),) + (IBitTorrentFile,)

    # This name appears in the 'add' box
    archetype_name = 'BitTorrent File'

    meta_type = 'BitTorrentFile'
    portal_type = 'BitTorrentFile'
    allowed_content_types = [] + list(getattr(ATFile, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 1
    allow_discussion = False
    content_icon = 'torrent.png'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "BitTorrent File"
    typeDescMsgId = 'description_edit_bittorrentfile'

    _at_rename_after_creation = True

    schema = BitTorrentFile_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods


registerType(BitTorrentFile, PROJECTNAME)
# end of class BitTorrentFile

##code-section module-footer #fill in your manual code here
##/code-section module-footer



