# -*- coding: utf-8 -*-
#
# File: ATVideo.py
#
# Copyright (c) 2006 by Nate Aune (Jazkarta), Andy Nicholson, Wolfgang Reutz
# Generator: ArchGenXML Version 1.5.0 svn/devel
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Nate Aune (Jazkarta) <natea@jazkarta.com>, Christof Haemmerle (nex9)
<reco@buero-newyork.com>, Chris Miles <chris@chrismiles.info>, Andy Nicholson
<andy@cat.org.au>, Wolfgang Reutz <wolfgang.reutz@vol.at>, Dave Fregon
<axxs@axxs.org>"""
__docformat__ = 'plaintext'


# There are three ways to inject custom code here:
#
#   - To set global configuration variables, create a file AppConfig.py.
#       This will be imported in config.py, which in turn is imported in
#       each generated class and in this file.
#   - To perform custom initialisation after types have been registered,
#       use the protected code section at the bottom of initialize().
#   - To register a customisation policy, create a file CustomizationPolicy.py
#       with a method register(context) to register the policy.

from zLOG import LOG, INFO

LOG('ATVideo',INFO, 'Installing Product')

try:
    import CustomizationPolicy
except ImportError:
    CustomizationPolicy = None

from Globals import package_home
from Products.CMFCore import utils as cmfutils
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore import DirectoryView
from Products.CMFPlone.PloneUtilities import ToolInit
from Products.Archetypes.atapi import *
from Products.Archetypes import listTypes
from Products.Archetypes.utils import capitalize

import os, os.path

from Products.ATVideo.config import *

DirectoryView.registerDirectory('skins', product_globals)
DirectoryView.registerDirectory('skins/ATVideo',
                                    product_globals)

##code-section custom-init-head #fill in your manual code here

# from http://sourceforge.net/mailarchive/message.php?msg_id=14868434
#
# Monkeypatch for sorted ATVocab lists
from Products.ATVocabularyManager.namedvocabulary import NamedVocabulary
def getDisplayList(self, instance):
     """ returns a object of class DisplayList as defined in
 	Products.Archetypes.utils.
 
 	The instance of the content class is given as parameter.
 
 	monkeypatched for sorted output
     """
     vocab = self.getVocabulary(instance)
     return vocab.getDisplayList(instance).sortedByKey()
NamedVocabulary.getDisplayList = getDisplayList
# end ATVocab monkeypatch

##/code-section custom-init-head


def initialize(context):
    ##code-section custom-init-top #fill in your manual code here
    ##/code-section custom-init-top

    # imports packages and types for registration
    import content
    import tool
    import interfaces


    # Initialize portal content
    all_content_types, all_constructors, all_ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    cmfutils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = all_content_types,
        permission         = DEFAULT_ADD_CONTENT_PERMISSION,
        extra_constructors = all_constructors,
        fti                = all_ftis,
        ).initialize(context)

    # Give it some extra permissions to control them on a per class limit
    for i in range(0,len(all_content_types)):
        klassname=all_content_types[i].__name__
        if not klassname in ADD_CONTENT_PERMISSIONS:
            continue

        context.registerClass(meta_type   = all_ftis[i]['meta_type'],
                              constructors= (all_constructors[i],),
                              permission  = ADD_CONTENT_PERMISSIONS[klassname])

    # Apply customization-policy, if theres any
    if CustomizationPolicy and hasattr(CustomizationPolicy, 'register'):
        CustomizationPolicy.register(context)
        print 'Customization policy for ATVideo installed'

    ##code-section custom-init-bottom #fill in your manual code here

#start validation
from Products.validation import validation
from validators import ImageTypeValidator, TimeValidator

validation.register(ImageTypeValidator('isImageType'))
validation.register(TimeValidator('isTimeType'))

#The custom metadata catalog search
import catalog_extension

##/code-section custom-init-bottom

