# -*- coding: utf-8 -*-

# ATVideo Project
# EngageMedia Branch

PROJECTNAME = "ATVideo"
product_globals = globals()


# Permissions and roles
from Products.CMFCore.CMFCorePermissions import setDefaultRoles

DEFAULT_ADD_CONTENT_PERMISSION = "Add portal content"
setDefaultRoles(DEFAULT_ADD_CONTENT_PERMISSION, ('Manager', 'Owner'))
ADD_CONTENT_PERMISSIONS = {
    'ATVideo': 'Add ATVideo Content',
    'ATEngageVideo': 'Add ATEngageVideo Content',
}

setDefaultRoles('Add ATVideo Content', ('Manager','Owner'))
setDefaultRoles('Add ATEngageVideo Content', ('Manager','Owner'))

# Translations and globals
from zope import i18n
_ = i18n.MessageIDFactory("atvideo")

TRANSCODING_STATUSES = { "-1": (False,
                                _(u"The transcoding failed.")),
                         "0" : (False,
                                _(u"The transcoding has started, "
                                  u"and not finished.")),
                         "1" : (True,
                                _(u"The transcoding has worked "
                                  u"successfully.")),
                         "2" : (False,
                                _(u"The transcoding has not started.")) }


# Dependencies of Products to be installed by quick-installer
# override in custom configuration
DEPENDENCIES = []
PRODUCT_DEPENDENCIES = []
# Dependend products - not quick-installed - used in testcase
# override in custom configuration



# Stylesheets and javascripts
STYLESHEETS = []
JAVASCRIPTS = [{'id':'duration_formfield.js'}]

# The ids of the new objects added inside Extension/AppInstall.py
TOPLEVEL_FOLDER    = "taxonomy"
GENRE_FOLDER       = "genre"
CATEGORIES_FOLDER  = "topic"
COUNTRIES_FOLDER   = "countries"
PEOPLE_FOLDER      = "people"
SUBMISSIONS_FOLDER = "callouts"

SYN_MANAGER = "syn_manager_video"
USE_SYN_MANAGER = False

DEFAULT_MB_FLDR = "default_member_content"

##/code-section config-bottom


# Load custom configuration not managed by ArchGenXML
try:
    from Products.ATVideo.AppConfig import *
except ImportError:
    pass
