#  Copyright (c) 2006 EngageMedia
#	andy nicholson andy@engagemedia.org
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
"""
A folder based on ATFolder to contain ATEngageVideo objects
"""
from Products.ATContentTypes.content.folder import ATFolder
from Products.ATContentTypes.content.folder import ATFolderSchema
from Products.Archetypes.public import Schema
from Products.Archetypes.public import registerType
from Products.ATVideo.config import PROJECTNAME

ATFolderSchemaCopy = ATFolderSchema.copy()

schema = ATFolderSchemaCopy 

class ATEngageVideoFolder(ATFolder):
    """A custom folder for holding videos
    """
    schema = schema
    global_allow = 1
    archetype_name = portal_type = meta_type = 'ATEngageVideoFolder'
    allowed_content_types = [ 'ATEngageVideo' ]
    filter_content_types = 1
    immediate_view = 'video_listing_view'
    default_view   = 'video_listing_view'
    suppl_views    = ()
    
    __implements__ = ATFolder.__implements__
    
registerType(ATEngageVideoFolder, PROJECTNAME)

