from Products.validation.interfaces.IValidator import IValidator
from Products.validation.validators.RangeValidator import RangeValidator
import re
import zLOG
from cStringIO import StringIO
import PIL.Image
import types

class ImageTypeValidator:
    """Image type validator, checks if image type
	is supported
    """
    __implements__ = (IValidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
       zLOG.LOG('ATEngageVideo', zLOG.INFO, "ImageTypeValidator has %s %s %s " % (value,args,kwargs))
       data=value.seek(0)
       data=value.read()
       value.seek(0)	
       filename=value.filename
       zLOG.LOG('ATEngageVideo',zLOG.INFO,"data size is %s , filename is %s " % (len(data),filename))

       original_file=StringIO(data)
       try:
       		image = PIL.Image.open(original_file)
       except:
       		return """The image type you are attempting to upload is not supported, please upload a different image type."""
       #worked, with no exception
       zLOG.LOG('ATEngageVideo',zLOG.INFO,"everything ok")
       return 1

class TimeValidator:
    """Checks that a valid duration has been selected from the TimeDurationWidget
    """
    __implements__ = (IValidator,)
    def __init__(self, name):
        self.name = name

    def __call__(self, value, *args, **kwargs):
       zLOG.LOG('ATEngageVideo', zLOG.INFO, "TimeValidator has %s %s %s %s " % (value,args,kwargs,type(value)))
       # XXX customise our own validation of the time
       # we need to check ACROSS the three time values, that they are not all 0
       (hour, min, secs) = value.split(":")
       zLOG.LOG('ATEngageVideo', zLOG.INFO, "TimeValidator has %s %s %s " % (hour,min,secs))

       if (int(hour) <= 0 and int(min) <=0 and int(secs) <=0):
	  return """Please select a valid time duration"""
       return 1
