## Controller Python Script "prefs_content_licensing_set"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=jurisdiction='',site_copyright='', rights_holder='', add_license='', newpub=''
##title=Set Content Licensing Parameters
##

ltool = context.portal_contentlicensing
mdtool = context.portal_metadata

message = ''

#Ignores 'empty' add_license
if add_license != ['', '', '']:
    #duplicates license name
    add_license[1] = add_license[0]
    #rewrites empty image pointer element
    if add_license[3] == '' :
        add_license[3] = 'None'
    license_id = 'license_%s' %add_license[0]
    license_id = string.join(license_id.lower().split(),"")
    ltool.manage_addProperty(license_id, add_license, 'lines')
    ltool.manage_changeProperties(SupportedLicenses=list(ltool.SupportedLicenses)+[license_id])
    ltool.manage_changeProperties(AvailableLicenses=list(ltool.AvailableLicenses)+[license_id])


#Redefines licenses that appear in the metadata widget for end users
supported_licenses = []            
for x in list(ltool.SupportedLicenses):
    supported_license = context.REQUEST.get('supported_'+x)
    if supported_license == 'on':
        supported_licenses.append(x)

ltool.manage_changeProperties(AvailableLicenses=supported_licenses)

#Sets the default license by grabbing the form node from the request object
default_site_license = context.REQUEST.license
if default_site_license:
    if default_site_license == 'Creative Commons License':
        req = context.REQUEST
        ccl = ("Creative Commons License",req.license_cc_name,req.license_cc_url,req.license_cc_button)
        ltool.manage_changeProperties(license_cc=ccl) 
        
    def_license = ltool.getLicense(default_site_license)
    ltool.manage_changeProperties(DefaultSiteLicense=def_license) 

ltool.manage_changeProperties(Jurisdiction=jurisdiction,
                              DefaultSiteCopyright=site_copyright,
                              DefaultSiteCopyrightHolder=rights_holder)

mdtool.editProperties(publisher=newpub)

if len(message) == 0:
    message += 'Your changes to the Content Licensing Tool have been applied.'

return state.set(context=context,portal_status_message=message)
                                                      
