import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.CMFPlone.tests import PloneTestCase
from unittest import TestSuite, makeSuite
from Testing import ZopeTestCase
from Testing.ZopeTestCase import user_name
from AccessControl import Unauthorized
from Products.ContentLicensing.DublinCoreExtensions.interfaces import ILicensable, ILicense

ZopeTestCase.installProduct('ContentLicensing')
PloneTestCase.setupPloneSite(products=('ContentLicensing',))

class testContentLicensing(PloneTestCase.PloneTestCase):
    def testContentLicensingInstall(self):
        assert PloneTestCase.hasProduct('ContentLicensing'), "ContentLicensing failed to install"

    def testGetLicense(self):
        cl_tool = self.portal.portal_contentlicensing
        assert cl_tool.getLicense('Other')

    def testGetLicenses(self):
        cl_tool = self.portal.portal_contentlicensing
        assert len(cl_tool.getLicenses()) == 5 

    def testIsLicensable(self):
        frontpage = self.portal.restrictedTraverse("front-page")
        cl_tool = self.portal.portal_contentlicensing
        assert cl_tool.isLicensable(frontpage)

    def testDefaultByline(self):
        frontpage = self.portal.restrictedTraverse("front-page")
        cl_tool = self.portal.portal_contentlicensing	
        assert len(cl_tool.getSiteDefaultLicenseByline()) == 5
    
    def testDefaultLicense(self):
        self.folder.invokeFactory('Document', 'testDoc')
        test_doc = self.folder.testDoc
        cl_tool = self.portal.portal_contentlicensing
        assert "Site Default" == cl_tool.getLicenseAndHolderFromObject(test_doc)[1][0]

    def testSetLicense(self):
        self.folder.invokeFactory('Document', 'testDoc')
        test_doc = self.folder.testDoc
        cl_tool = self.portal.portal_contentlicensing
        other_license = ['Other', 'MyLicense', 'None', 'None']
        cl_tool.setRightsLicense(test_doc, other_license)
        assert "Other" == cl_tool.getLicenseAndHolderFromObject(test_doc)[1][0]

    def testSetRightsHolder(self):
        self.folder.invokeFactory('Document', 'testDoc')
        test_doc = self.folder.testDoc
        cl_tool = self.portal.portal_contentlicensing
        rights_holder = 'David Ray'
        cl_tool.setRightsHolder(test_doc, rights_holder)
        assert rights_holder  == cl_tool.getLicenseAndHolderFromObject(test_doc)[0]

    def testCCSiteDefaulWriteRDF(self):
        frontpage = self.portal.restrictedTraverse("front-page")
        cl_tool = self.portal.portal_contentlicensing
        cl_tool.DefaultSiteLicense = ['Creative Commons License',
                                      'Attribution-Noncommercial-Share Alike 3.0',
                                      'http://creativecommons.org/licenses/by-nc-sa/3.0/',
                                      'http://i.creativecommons.org/l/by-nc-sa/3.0/88x31.png']
        assert "<License" in frontpage.view()

    def testJurisdictionUnported(self):
        assert(self.portal.portal_contentlicensing.Jurisdiction == 'Unported')

def test_suite():
    suite = TestSuite()
    suite.addTest(makeSuite(testContentLicensing))
    return suite

if __name__ == '__main__':
    framework()
