"""This is the configuration file for PlumiSkin.
Customizing the following infos is the way to go to personalize
your Plumi install.

Homepage:
---------
  The homepage is the default page of your portal. It's the item displayed
  when you arrive at the root. In Plumi, the homepage is a list of diverse
  items fetched in the portal : featured videos, feature items, etc... You
  can choose the layout be customizing the following variable :

    HOMEPAGE = 'name_of_the_template_or_view'

Stylesheets:
------------
  The stylesheets can be defined this way :
  
    STYLESHEETS = [{'id': 'plumi.css'},
                   {'id': 'plumimember.css',
                    'expression': 'not: portal/portal_membership/isAnonymousUser'}]

  The 'expression' statement is a TALES expression.

Dependencies:
-------------
  Dependencies are the products needed for PlumiSkin. They are considered
  as necessary for the install. To define a dependency, please respect the
  following syntax:

    DEPENDENCIES = ['Name of the product', 'Name of another product',]

  Adding a dependency to the existing ones mean to append a string to the list.

User:
-----
  A fresh install of Plumi will create a brand new user, with admin rights.
  The user is defined here as following :

    USER = dict(id='userid', fullname='name of the user', email='some@ema.il')

  All these keys are mandatory. Feel free to customize it your way.
"""

HOMEPAGE = "featured_videos_homepage"
VIDEO_TOPIC_PAGE = "videos_topic_view"

# plumi homepage CSS was originaly destined to the sole homepage
# but, as it might be useful in other places, the condition has been
# removed
STYLESHEETS = [{'id': 'plumi.css'},
               {'id': 'plumi_homepage.css'}]

DEPENDENCIES = ['PloneCaptcha',
                'Vaporisation',
                'Portletification',
                'DataGridField',
                'qPloneCaptchas',
                'qPloneComments']

USER = dict(id = "Plumi",
            fullname = "Plumi",
            email = "contact@plumi.org.yourdomain")

# Default Member folders
CALLOUT_FOLDER = dict(id="callouts",title="Call Outs")
VIDEO_FOLDER = dict(id="videos",title="Videos")
NEWS_FOLDER = dict(id="news",title="News")
EVENTS_FOLDER = dict(id="events",title="Events")

#Member migration details
# Set this to FALSE, once its been done once , after upgrading to the fixed personalise_form
UPDATE_USER_LISTED_IN_SEARCHES = False
#This only needs to be true if you wish to delete the exisiting Call Outs folder, which was only useful during development.
DELETE_EXISTING_CALLOUT_FOLDER = False
