# -*- coding: utf-8 -*-

from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.Extensions.utils import install_subskin
from Products.Portletification.config import product_globals, right_name

def install(self):
    """
    Install Portletification
    """
    out = StringIO()

    # Install skin
    install_subskin(self, out, product_globals)

    # Add index
    pc = getToolByName(self, 'portal_catalog')
    if 'object_implements' not in pc.indexes():
        pc.addIndex('object_implements', 'KeywordIndex')
        out.write('Added object_implements index to portal_catalog\n')

    if 'portletified' not in pc.indexes():
        pc.addIndex('portletified', 'KeywordIndex')
        out.write('Added portletified index to portal_catalog\n')

    # Adds the portlet in the columns
    left  = list(self.getProperty('left_slots'))
    right = list(self.getProperty('right_slots'))

    if 'here/render_portletification/macros/left' not in left:
        left.append('here/render_portletification/macros/left')
        self.manage_changeProperties(**{'left_slots'  : left})
    
    if 'here/render_portletification/macros/right' not in right:
        right.append('here/render_portletification/macros/right')
        self.manage_changeProperties(**{'right_slots' : right})


    # Add action
    # Uglier than a wookie butt
    at = getToolByName(self, 'portal_actions')
    ai = getToolByName(self, 'portal_actionicons')
    try:
        at.addAction('portletification-tag-left',
                     name='Tag as left portlet',
                     action='string:${globals_view/getCurrentObjectUrl}/portlet_provider/portletify?position=left',
                     condition="object/portlet_actions/tag_left",
                     permission=right_name,
                     category='object_buttons')

        ai.addActionIcon('object_buttons',
                         'portletification-tag-left',
                         'portletify_left.gif',
                         'Tag as left portlet', 0)
    except:
        pass

    try:
        at.addAction('portletification-untag-left',
                     name='Untag as left portlet',
                     action='string:${globals_view/getCurrentObjectUrl}/portlet_provider/unportletify?position=left',
                     condition="object/portlet_actions/untag_left",
                     permission=right_name,
                     category='object_buttons')

        ai.addActionIcon('object_buttons',
                         'portletification-untag-left',
                         'unportletify_left.gif',
                         'Untag as left portlet', 0)
    except:
        pass

    try:
        at.addAction('portletification-tag-right',
                     name='Tag as right portlet',
                     action='string:${globals_view/getCurrentObjectUrl}/portlet_provider/portletify?position=right',
                     condition="object/portlet_actions/tag_right",
                     permission=right_name,
                     category='object_buttons')

        ai.addActionIcon('object_buttons',
                         'portletification-tag-right',
                         'portletify_right.gif',
                         'Tag as right portlet', 0)
    except:
        pass

    try:
        at.addAction('portletification-untag-right',
                     name='Untag as right portlet',
                     action='string:${globals_view/getCurrentObjectUrl}/portlet_provider/unportletify?position=right',
                     condition="object/portlet_actions/untag_right",
                     permission=right_name,
                     category='object_buttons')

        ai.addActionIcon('object_buttons',
                         'portletification-untag-right',
                         'unportletify_right.gif',
                         'Untag as right portlet', 0)
    except:
        pass

    return out.getvalue()
