# -*- coding: utf-8 -*-
from zope.interface import Interface
from zope.app.event.interfaces import IObjectModifiedEvent


class IListingContentProvider( Interface ):
    """ Provides the contents of a folder """

    def getLimitedContents( ):
        """
        Returns the content of the folder,
        limited to $limit objects
        """

    def getContents( ):
        """
        Returns the content of the folder
        """

    def normalizeString( ):
        """
        It changes the given string into a string stripped
        of all non-ascii and non-URLish characters.
        """

    def getViewUrl( ):
        """
        This simple methods returns the URL to view the item
        according to the preferences set into the portal.
        Mainly, it will return the absolute url or the absolute url
        plus /view, for certain items (file, link, image...)
        """


class IPortletRetriever( Interface ):
    """
    """

    def getLeftPortlets( self ):
        """
        Returns the list of left portlets
        """

    def getRightPortlets( self ):
        """
        Returns the list of right portlets
        """
    

class IPortletifiable( Interface ):
    """
    """
    
    def portletified(self):
        """
        Returns a dict with the positions as keys.
        True for a position means that the object is tagged to appear
        as a portlet at this particular position.
        """

    def portletify(self, position):
        """
        Adds the object at the given position, to be rendered as a portlet
        """

    def unportletify(self, position):
        """
        Removes the object at the given position
        """


class IPortlet( Interface ):
    """
    Marker interface
    """


class IObjectTaggedAsPortlet( IObjectModifiedEvent ):
    """ event marker """


class IObjectUntaggedAsPortlet( IObjectModifiedEvent ):
    """ event marker """

